#include <iostream>
#include <string>
#include <sstream>
#include <cstdlib>

using namespace std;

class Monster {
protected:
    Monster():maxHealth(100+rand()%156){ health=maxHealth; }
    Monster(const string & name_, int health_, int maxHealth_):health(health_),maxHealth(maxHealth_),name(name_){ ; }

    int health;
    int maxHealth;
    string name;
public:
    string getName() const { return name; }
    void setName(const string & name_){ name = name_; }
    int getHealth() const { return health; }
    void setHealth(int h){ health = h; }
    int getMaxHealth() const { return maxHealth; }
    void setMaxHealth(int h){ maxHealth = h; }

    virtual std::ostream & print(std::ostream & out) const = 0;
};

struct Troll: public Monster {
    Troll(){ setName("Brick"); }
    Troll(const string & name_, int health_, int maxHealth_):Monster(name_, health_, maxHealth_) { ; }

    virtual std::ostream & print(std::ostream & out) const {
        return out << "troll" << " \"" << getName() << "\" " << getHealth() << " / " << getMaxHealth();
    }
};

struct Spider: public Monster {
    Spider(){ setName("Odula"); }
    Spider(const string & name_, int health_, int maxHealth_):Monster(name_, health_, maxHealth_) { ; }
    virtual std::ostream & print(std::ostream & out) const {
        return out << "spider" << " \"" << getName() << "\" " << getHealth() << " / " << getMaxHealth();
    }
};

std::ostream & operator<<(std::ostream & out, const Monster & s){
    return s.print(out);
}

std::istream & operator>>(std::istream & in, Monster & m){
    std::string tmpLine;
    std::getline(in, tmpLine);

    size_t qtStart = tmpLine.find_first_of("\"") + 1; // swallow start "
    size_t qtEnd = tmpLine.find_last_of("\"");

    string name = tmpLine.substr(qtStart, qtEnd - qtStart);
    m.setName(name);

    std::stringstream tmpIn;
    tmpIn.str(tmpLine.substr(qtEnd + 1)); // swallow end "

    int health;
    tmpIn >> health;

    char slash;
    tmpIn >> slash;

    int maxHealth;
    tmpIn >> maxHealth;

    m.setMaxHealth(maxHealth);
    m.setHealth(health);

    return in;
}

int main()
{
    Troll brick;
    cout << "vytvorte trola: ";
    cin >> brick;
    Monster & m = brick;
    cout << m << endl;

    return 0;
}

